import numpy as np
import os
import shutil
import math
import glob
#from plotOMF import plotOMF02
#from plotOMF import plotOMFcustomarrow
from matplotlib import pyplot as plt
from matplotlib.colors import hsv_to_rgb
import colorsys
from skimage import measure
import matplotlib.ticker as ticker
import matplotlib.font_manager as fm
from colour import Color
import matplotlib.gridspec as gridspec
"""
======================
Definitions
======================
"""
def cm2inch(value):
    return value/2.54

Aalto_yellow = '#FECB00'
Aalto_orange = '#FF7900'
Aalto_red = '#ED2939'
Aalto_violet = '#B1059D'
Aalto_purple = '#6639B7'
Aalto_blue = '#0065BD'
Aalto_turqoise = '#00A8B4'
Aalto_green = '#009B3A'
Aalto_light_green = '#69BE28'
Aalto_grey = '#928B81'


"""
======================
0. experimental angles
======================
"""

c_a_direction = 29
c_b_direction = -13.85
uc_a_direction = -150.14
uc_b_direction = -32.35

c_a_error = 1.52
c_b_error = 2.2
uc_a_error = 2.01
uc_b_error = 2.71


"""
======================
1. import files
======================
"""

data0p9_c_7e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_7e3_c_profile.txt',skiprows=2)
data0p9_uc_7e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_7e3_uc_profile.txt',skiprows=2)
data0p9_c_8e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_8e3_c_profile.txt',skiprows=2)
data0p9_uc_8e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_8e3_uc_profile.txt',skiprows=2)
data0p9_c_9e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_9e3_c_profile.txt',skiprows=2)
data0p9_uc_9e3 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_9e3_uc_profile.txt',skiprows=2)
data0p9_c_1e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_1e4_c_profile.txt',skiprows=2)
data0p9_uc_1e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_1e4_uc_profile.txt',skiprows=2)
data0p9_c_1p1e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_1p1e4_c_profile.txt',skiprows=2)
data0p9_uc_1p1e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_1p1e4_uc_profile.txt',skiprows=2)
data0p9_c_1p2e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_1p2e4_c_profile.txt',skiprows=2)
data0p9_uc_1p2e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_1p2e4_uc_profile.txt',skiprows=2)
data0p9_c_1p3e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/c/analysis/profiles/Kip_1p3e4_c_profile.txt',skiprows=2)
data0p9_uc_1p3e4 = np.loadtxt('anisotropy_fitting/0p9um_stripe/uc/analysis/profiles/Kip_1p3e4_uc_profile.txt',skiprows=2)

data1p0_c_7e3 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_7e3_c_profile.txt',skiprows=2)
data1p0_uc_7e3 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_7e3_uc_profile.txt',skiprows=2)
data1p0_c_8e3 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_8e3_c_profile.txt',skiprows=2)
data1p0_uc_8e3 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_8e3_uc_profile.txt',skiprows=2)
data1p0_c_9e3 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_9e3_c_profile.txt',skiprows=2)
data1p0_uc_9e3 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_9e3_uc_profile.txt',skiprows=2)
data1p0_c_1e4 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_1e4_c_profile.txt',skiprows=2)
data1p0_uc_1e4 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_1e4_uc_profile.txt',skiprows=2)
data1p0_c_1p1e4 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_1p1e4_c_profile.txt',skiprows=2)
data1p0_uc_1p1e4 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_1p1e4_uc_profile.txt',skiprows=2)
data1p0_c_1p2e4 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_1p2e4_c_profile.txt',skiprows=2)
data1p0_uc_1p2e4 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_1p2e4_uc_profile.txt',skiprows=2)
data1p0_c_1p3e4 = np.loadtxt('anisotropy_fitting/1um_stripe/c/analysis/profiles/Kip_1p3e4_c_profile.txt',skiprows=2)
data1p0_uc_1p3e4 = np.loadtxt('anisotropy_fitting/1um_stripe/uc/analysis/profiles/Kip_1p3e4_uc_profile.txt',skiprows=2)

data1p1_c_7e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_7e3_c_profile.txt',skiprows=2)
data1p1_uc_7e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_7e3_uc_profile.txt',skiprows=2)
data1p1_c_8e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_8e3_c_profile.txt',skiprows=2)
data1p1_uc_8e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_8e3_uc_profile.txt',skiprows=2)
data1p1_c_9e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_9e3_c_profile.txt',skiprows=2)
data1p1_uc_9e3 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_9e3_uc_profile.txt',skiprows=2)
data1p1_c_1e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_1e4_c_profile.txt',skiprows=2)
data1p1_uc_1e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_1e4_uc_profile.txt',skiprows=2)
data1p1_c_1p1e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_1p1e4_c_profile.txt',skiprows=2)
data1p1_uc_1p1e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_1p1e4_uc_profile.txt',skiprows=2)
data1p1_c_1p2e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_1p2e4_c_profile.txt',skiprows=2)
data1p1_uc_1p2e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_1p2e4_uc_profile.txt',skiprows=2)
data1p1_c_1p3e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/c/analysis/profiles/Kip_1p3e4_c_profile.txt',skiprows=2)
data1p1_uc_1p3e4 = np.loadtxt('anisotropy_fitting/1p1um_stripe/uc/analysis/profiles/Kip_1p3e4_uc_profile.txt',skiprows=2)


DW_4um_Ku1e4_LC_t4 = np.loadtxt('t-dep_4um/LC/analysis/profiles/Ms_1p46e6_Kip1e4_t4_LC_profile.txt',skiprows=2) 
DW_4um_Ku1e4_LU_t4 = np.loadtxt('t-dep_4um/LU/analysis/profiles/Ms_1p46e6_Kip1e4_t4_LU_profile.txt',skiprows=2)
DW_4um_Ku1e4_SC_t4 = np.loadtxt('t-dep_4um/SC/analysis/profiles/Ms_1p46e6_Kip1e4_t4_SC_profile.txt',skiprows=2)
DW_4um_Ku1e4_SU_t4 = np.loadtxt('t-dep_4um/SU/analysis/profiles/Ms_1p46e6_Kip1e4_t4_SU_profile.txt',skiprows=2)


"""
======================
2. define parameters for plots
======================
"""
x23min = 0.9e3
x23max = 3.1e3

x23shift = 2e3
x23scaling = 0.001


ySCmin = -36
ySCmax = 36
ySCint = 30
ySCtickmin = -30
yLUmin = -162
yLUmax = -18
yLUint = 60
yLUtickmin = -150
yLCmin = -72
yLCmax = 72
yLCint = 60
yLCtickmin = -60
ySUmin = -126
ySUmax = -54
ySUint = 30
ySUtickmin = -120

y23ticknumber = 3

y23Shift = -90

"""
2. define parameters of Figure:
"""
label_fontsize = 8
tick_fontsize = 6

plotlinewidth = 1
tick_length = 3

datapointsize = 4
errorcapwidth = 2


para1_label = '$domain$ $width$ [$\mathrm{\mu}$m]'
para2_label = '$\phi$ [$^{\circ}$]'


# define panel size and position:
width = 8.6
heightratio = 0.6
figuresize=(cm2inch(width), cm2inch(heightratio*width))

xpos1 = 0.12
xpos2 = 0.58
xpos3 = 0.58

ypos1 = 0.13
ypos2 = 0.56
ypos3 = 0.13

panelwidth1 = 0.32
panelwidth2 = 0.3
panelheight1 = 0.86
panelheight2 = 0.43

panel_a = [xpos1, ypos1, panelwidth1, panelheight1]
panel_b = [xpos2, ypos2, panelwidth2, panelheight2]
panel_c = [xpos3, ypos3, panelwidth2, panelheight2]





xlabelpad = 0
xlabelpadtop = 5
ylabelpad = 1

"""
======================
3. make Figure
======================
"""
fig = plt.figure(num=None, figsize=figuresize, dpi=80, facecolor='w', edgecolor='k')
ax1 = fig.add_axes(panel_a, label ='1')
ax2 = fig.add_axes(panel_b, label ='2')
ax3 = fig.add_axes(panel_c, label ='3')
ax21 = fig.add_axes(panel_b, label ='21')
ax31 = fig.add_axes(panel_c, label ='31')

ax21.patch.set_alpha(0.0)
ax31.patch.set_alpha(0.0)


"""
======================
4. create angles as fct of width for all Kip
======================
"""
Kip7e3 = np.array([[0.9,90-np.amax(data0p9_c_7e3[:,1])],[1.0,90-np.amax(data1p0_c_7e3[:,1])],[1.1,90-np.amax(data1p1_c_7e3[:,1])]])
Kip8e3 = np.array([[0.9,90-np.amax(data0p9_c_8e3[:,1])],[1.0,90-np.amax(data1p0_c_8e3[:,1])],[1.1,90-np.amax(data1p1_c_8e3[:,1])]])
Kip9e3 = np.array([[0.9,90-np.amax(data0p9_c_9e3[:,1])],[1.0,90-np.amax(data1p0_c_9e3[:,1])],[1.1,90-np.amax(data1p1_c_9e3[:,1])]])
Kip1e4 = np.array([[0.9,90-np.amax(data0p9_c_1e4[:,1])],[1.0,90-np.amax(data1p0_c_1e4[:,1])],[1.1,90-np.amax(data1p1_c_1e4[:,1])]])
Kip1p1e4 = np.array([[0.9,90-np.amax(data0p9_c_1p1e4[:,1])],[1.0,90-np.amax(data1p0_c_1p1e4[:,1])],[1.1,90-np.amax(data1p1_c_1p1e4[:,1])]])
Kip1p2e4 = np.array([[0.9,90-np.amax(data0p9_c_1p2e4[:,1])],[1.0,90-np.amax(data1p0_c_1p2e4[:,1])],[1.1,90-np.amax(data1p1_c_1p2e4[:,1])]])
Kip1p3e4 = np.array([[0.9,90-np.amax(data0p9_c_1p3e4[:,1])],[1.0,90-np.amax(data1p0_c_1p3e4[:,1])],[1.1,90-np.amax(data1p1_c_1p3e4[:,1])]])

experimental = np.array([[0.8,c_b_direction,c_b_direction-c_b_error,c_b_direction+c_b_error],[1.2,c_b_direction,c_b_direction-c_b_error,c_b_direction+c_b_error]])

"""
======================
5. plot everything
======================
"""
ax1.plot(experimental[:,0], experimental[:,1], color='black', linewidth=plotlinewidth)
ax1.fill_between(experimental[:,0], experimental[:,2], experimental[:,3], color = Aalto_grey)

ax1.plot(Kip7e3[:,0], Kip7e3[:,1],'o',markersize = datapointsize, color=Aalto_red, label ='7e3 J/m$^3$')
ax1.plot(Kip8e3[:,0], Kip8e3[:,1],'o',markersize = datapointsize, color=Aalto_purple, label ='8e3 J/m$^3$')
ax1.plot(Kip9e3[:,0], Kip9e3[:,1],'o',markersize = datapointsize, color=Aalto_turqoise, label ='9e3 J/m$^3$')
ax1.plot(Kip1e4[:,0], Kip1e4[:,1],'o',markersize = datapointsize, color=Aalto_light_green, label ='1e4 J/m$^3$')
ax1.plot(Kip1p1e4[:,0], Kip1p1e4[:,1],'o',markersize = datapointsize, color=Aalto_orange, label ='1.1e4 J/m$^3$')
ax1.plot(Kip1p2e4[:,0], Kip1p2e4[:,1],'o',markersize = datapointsize, color=Aalto_violet, label ='1.2e4 J/m$^3$')
ax1.plot(Kip1p3e4[:,0], Kip1p3e4[:,1],'o',markersize = datapointsize, color=Aalto_green, label ='1.3e4 J/m$^3$')

ax2.plot(DW_4um_Ku1e4_SC_t4[:,0], DW_4um_Ku1e4_SC_t4[:,1]+y23Shift, color = Aalto_orange, linewidth=plotlinewidth)
ax21.plot(DW_4um_Ku1e4_LU_t4[:,0], DW_4um_Ku1e4_LU_t4[:,1]+y23Shift, color = Aalto_violet, linewidth=plotlinewidth)
ax3.plot(DW_4um_Ku1e4_LC_t4[:,0], DW_4um_Ku1e4_LC_t4[:,1]+y23Shift,'--', color = Aalto_blue, linewidth=plotlinewidth)
ax31.plot(DW_4um_Ku1e4_SU_t4[:,0], DW_4um_Ku1e4_SU_t4[:,1]+y23Shift,'--', color = Aalto_green, linewidth=plotlinewidth)


"""
======================
6. adjust Figure design
======================
"""
#set limits
ax1.set_xlim(0.88, 1.12)
ax1.set_ylim(-19, -7)

ax2.set_xlim(x23min, x23max)
ax21.set_xlim(x23min, x23max)
ax3.set_xlim(x23min, x23max)
ax31.set_xlim(x23min, x23max)
ax2.set_ylim(ySCmin, ySCmax)
ax21.set_ylim(yLUmax, yLUmin)
ax3.set_ylim(yLCmin, yLCmax)
ax31.set_ylim(ySUmax, ySUmin)



#set positions of ticks and scale:
ax1.xaxis.set_major_locator(plt.MultipleLocator(0.1))
ax1.yaxis.set_major_locator(plt.MultipleLocator(2))

SCticks = np.arange(ySCtickmin,ySCmax,ySCint)
ax2.set_yticks(SCticks)
LUticks = np.arange(yLUtickmin,yLUmax,yLUint)
ax21.set_yticks(LUticks)
LCticks = np.arange(yLCtickmin,yLCmax,yLCint)
ax3.set_yticks(LCticks)
SUticks = np.arange(ySUtickmin,ySUmax,ySUint)
ax31.set_yticks(SUticks)

x_ticks = ticker.FuncFormatter(lambda x, pos: '{0:g}'.format((x-x23shift)*x23scaling))
ax2.xaxis.set_major_formatter(x_ticks)
ax21.xaxis.set_major_formatter(x_ticks)
ax3.xaxis.set_major_formatter(x_ticks)
ax31.xaxis.set_major_formatter(x_ticks)

# position ticks
ax1.tick_params(bottom=True, top=True, left=True, right=True, labelbottom=True, labeltop=False, labelleft=True, labelright=False, direction='in', labelsize=tick_fontsize, length=tick_length)
ax2.tick_params(bottom=True, top=True, left=True, right=False, labelbottom=False, labeltop=False, labelleft=True, labelright=False, direction='in', labelsize=tick_fontsize)
ax21.tick_params(bottom=True, top=True, left=False, right=True, labelbottom=False, labeltop=False, labelleft=False, labelright=True, direction='in', labelsize=tick_fontsize)
ax3.tick_params(bottom=True, top=True, left=True, right=False, labelbottom=True, labeltop=False, labelleft=True, labelright=False, direction='in', labelsize=tick_fontsize)
ax31.tick_params(bottom=True, top=True, left=False, right=True, labelbottom=True, labeltop=False, labelleft=False, labelright=True, direction='in', labelsize=tick_fontsize)
ax2.tick_params(axis='y', colors= Aalto_orange)
ax21.tick_params(axis='y', colors= Aalto_violet)
ax3.tick_params(axis='y', colors= Aalto_blue)
ax31.tick_params(axis='y', colors= Aalto_green)

# set labels of axes
ax1.set_xlabel(para1_label, fontsize = label_fontsize,labelpad=xlabelpad)
ax1.set_ylabel(para2_label, fontsize = label_fontsize,labelpad=xlabelpad)
#ax2.set_xlabel('$position$ [$\mu$m]', fontsize = label_fontsize, labelpad=xlabelpad)
ax3.set_xlabel('$position$ [$\mu$m]', fontsize = label_fontsize, labelpad=xlabelpad)
ax2.set_ylabel(para2_label, fontsize = label_fontsize,labelpad=xlabelpad, color = Aalto_orange)
ax21.set_ylabel(para2_label, fontsize = label_fontsize,labelpad=xlabelpad, color = Aalto_violet)
ax21.yaxis.set_label_position("right")
ax3.set_ylabel(para2_label, fontsize = label_fontsize,labelpad=xlabelpad,color = Aalto_blue)
ax31.set_ylabel(para2_label, fontsize = label_fontsize,labelpad=xlabelpad, color = Aalto_green)
ax31.yaxis.set_label_position("right")

#add legend
#ax1.legend(loc='upper left', bbox_to_anchor=(0.55, 0.99),ncol =1, fontsize = tick_fontsize, labelspacing =0.0, framealpha =0.5)

ax1.text(1.02, Kip7e3[1,1], '$0.7$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_red)
ax1.text(1.02, Kip8e3[1,1], '$0.8$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_purple)
ax1.text(1.02, Kip9e3[1,1], '$0.9$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_turqoise)
ax1.text(1.02, Kip1e4[1,1], '$1$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_light_green)
ax1.text(1.02, Kip1p1e4[1,1], '$1.1$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_orange)
ax1.text(1.02, Kip1p2e4[1,1], '$1.2$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_violet)
ax1.text(1.02, Kip1p3e4[1,1], '$1.3$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = Aalto_green)
ax1.text(0.98, -8, r'$\times 10^{4}$ J/m$^{3}$', horizontalalignment='left',verticalalignment='center',fontsize = label_fontsize,color = 'black')

ax2.text(0.1,0.8,'60C',color = Aalto_orange,fontsize=label_fontsize,transform=ax2.transAxes)
ax2.text(0.1,0.65,'120U',color = Aalto_violet,fontsize=label_fontsize,transform=ax2.transAxes)
ax3.text(0.1,0.8,'120C',color = Aalto_blue,fontsize=label_fontsize,transform=ax3.transAxes)
ax3.text(0.1,0.65,'60U',color = Aalto_green,fontsize=label_fontsize,transform=ax3.transAxes)


"""
add panel labels
"""
axlabels = fig.add_axes([0,0,1,1],label ='labels')
axlabels.axis('off')
axlabels.patch.set_alpha(0.0)
axlabels.text(0.01,0.94,'(a)',fontsize=label_fontsize)
axlabels.text(0.47,0.94,'(b)',fontsize=label_fontsize)
axlabels.text(0.47,0.50,'(c)',fontsize=label_fontsize)
axlabels.tick_params(bottom=False, top=False, left=False, right=False, labelbottom=False, labeltop=False, labelleft=False, labelright=False)


"""
======================
show and/or save plot
======================
"""

plt.savefig('simulations.pdf', bbox_inches = 'tight',pad_inches = 0)
#plt.show()
plt.clf()



